"""
This module...
"""

from .DatasetVersion import DatasetVersion
from .Serializable import JsonSerializable


class ObjectDatasetVersion(DatasetVersion, JsonSerializable):
    """
    This class...
    """

    def __init__(self,
                 name: str = None,
                 id: int = None):
        # id is autogenerated during commits
        self._id = id
        self._name = name

    @property
    def id(self) -> int:
        """

        :return:
        """
        return self._id

    @property
    def name(self) -> str:
        """

        :return:
        """
        return self._name

    @classmethod
    def from_id(cls,
                id: int):  # TODO: uncomment after migration to python 3.11 -> Self:
        """

        :param id:
        :return:
        """
        return ObjectDatasetVersion(id=id)

    def to_json(self) -> dict:
        """

        :return:
        """
        to_return = {
            "id": self.id,
            "name": self.name
        }
        return to_return

    @classmethod
    def from_json(cls,
                  json_dict: dict):
        """

        :param json_dict:
        :return:
        """

        if json_dict is None:
            return ObjectDatasetVersion()

        return ObjectDatasetVersion(
            id=json_dict['id'],
            name=json_dict['name'])


